/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "controls.h"

FD_controls *create_form_controls(void)
{
  FL_OBJECT *obj;
  FD_controls *fdui = (FD_controls *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->controls = fl_bgn_form(FL_NO_BOX, 490, 95);
  fdui->form = obj = fl_add_box(FL_FLAT_BOX,0,0,490,95,"");
  obj = fl_add_box(FL_UP_BOX,0,0,490,20,"");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthEast);
  fdui->play_pause = obj = fl_add_button(FL_NORMAL_BUTTON,5,25,21,20,"@>");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_PLAY_PAUSE);
  fdui->step = obj = fl_add_button(FL_NORMAL_BUTTON,75,25,36,20,"Step");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_STEP);
  fdui->stop = obj = fl_add_button(FL_NORMAL_BUTTON,47,25,21,20,"@square");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_STOP);
  fdui->time_total = obj = fl_add_text(FL_NORMAL_TEXT,436,53,50,15,"00:00:00");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->time_elapsed = obj = fl_add_text(FL_NORMAL_TEXT,5,53,50,15,"00:00:00");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
  fdui->end = obj = fl_add_button(FL_NORMAL_BUTTON,138,25,21,20,"@->|");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_END);
  fdui->actual_framerate = obj = fl_add_text(FL_NORMAL_TEXT,450,75,35,15,"0.0");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->actual_framerate_label = obj = fl_add_text(FL_NORMAL_TEXT,405,70,45,25,"at fps:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->number_of_frames_played_label = obj = fl_add_text(FL_NORMAL_TEXT,230,70,115,25,"frames played:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->number_of_frames_played = obj = fl_add_text(FL_NORMAL_TEXT,345,75,55,15,"0");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->loop = obj = fl_add_checkbutton(FL_PUSH_BUTTON,165,25,50,20,"Loop");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_LOOP);
  fdui->file_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,2,2,41,16,"File");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_FILE_MENU);
  fdui->options_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,40,2,62,16,"Options");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_OPTIONS_MENU);
  fdui->help_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,445,2,45,16,"Help");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_HELP_MENU);
  fdui->audio_mute = obj = fl_add_checkbutton(FL_PUSH_BUTTON,275,25,50,20,"Mute");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_MUTE);
  fdui->frame_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,55,50,380,20,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_SEEK);
  fdui->audio_volume_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,340,35,65,15,"- Volume +");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_VOLUME);
  fdui->audio_balance_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,415,35,65,15,"L Balance R");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_BALANCE);
  fdui->window_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,105,2,63,16,"Window");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_WINDOW_MENU);
  fdui->zoom = obj = fl_add_checkbutton(FL_PUSH_BUTTON,220,25,50,20,"Zoom");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_ZOOM);
  fdui->rewind = obj = fl_add_button(FL_NORMAL_BUTTON,117,25,21,20,"@4->|");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_REWIND);
  fdui->fast_forward = obj = fl_add_button(FL_INOUT_BUTTON,26,25,21,20,"@>>");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_FAST_FORWARD);
  fdui->oneliner_timer = obj = fl_add_timer(FL_HIDDEN_TIMER,235,75,25,15,"");
    fl_set_object_callback(obj,oneliner_timer_CB,0);
  obj = fl_add_button(FL_NORMAL_BUTTON,80,65,130,30,"MpegTV  1.0");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lcolor(obj,FL_GREEN);
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE+FL_SHADOW_STYLE);
    fl_set_object_callback(obj,command,COM_DEMO);
  fdui->vcd_track = obj = fl_add_counter(FL_SIMPLE_COUNTER,5,75,55,15,"");
    fl_set_object_callback(obj,command,COM_VCD_TRACK);
    fl_set_counter_precision(obj, 0);
    fl_set_counter_bounds(obj, 1, 99);
    fl_set_counter_value(obj, 1);
    fl_set_counter_step(obj, 1, 1);
  fdui->update_slider_timer = obj = fl_add_timer(FL_HIDDEN_TIMER,225,75,25,15,"");
    fl_set_object_callback(obj,update_slider_timer_CB,0);
  fl_end_form();

  fdui->controls->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_about *create_form_about(void)
{
  FL_OBJECT *obj;
  FD_about *fdui = (FD_about *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->about = fl_bgn_form(FL_NO_BOX, 410, 345);
  obj = fl_add_box(FL_UP_BOX,0,0,410,345,"");
    fl_set_object_color(obj,FL_LEFT_BCOL,FL_COL1);
  obj = fl_add_text(FL_NORMAL_TEXT,0,105,410,29,"Copyright (c) 1997 MpegTV, all rights reserved");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,0,410,48,"MpegTV Player 1.0");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_WHITE,FL_MCOL);
    fl_set_object_lsize(obj,FL_HUGE_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,130,410,45,"Portions of this software:\nCopyright (c) 1995, 1996 by T.C. Zhao and Mark Overmars\nAll rights reserved");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->version = obj = fl_add_text(FL_NORMAL_TEXT,0,45,410,26,"Version xxx");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
  obj = fl_add_button(FL_NORMAL_BUTTON,170,310,64,22,"OK");
    fl_set_object_color(obj,FL_MCOL,FL_COL1);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_ABOUT_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,269,410,31,"http://www.mpegtv.com");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,175,410,95,"This software was developed with MpegTV SDK 1.0, a toolkit\nfor playing real-time MPEG from X Window applications.\n\nFor more information on MpegTV SDK 1.0 for Unix\nplease visit the MpegTV website:");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->about->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_audio *create_form_audio(void)
{
  FL_OBJECT *obj;
  FD_audio *fdui = (FD_audio *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->audio = fl_bgn_form(FL_NO_BOX, 405, 160);
  obj = fl_add_box(FL_UP_BOX,0,0,405,160,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,175,130,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_AUDIO_CLOSE);

  fdui->audio_ch_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,15,25,105,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,15,60,20,"Channels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_ch_both = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,40,90,15,"Both (stereo)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_BOTH);
  fdui->audio_ch_left = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,65,90,15,"Left (mono)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_LEFT);
  fdui->audio_ch_right = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,90,90,15,"Right (mono)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_RIGHT);
  fl_end_group();


  fdui->audio_controls_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,225,25,70,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,230,15,55,20,"Controls");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_controls_pcm = obj = fl_add_roundbutton(FL_RADIO_BUTTON,230,65,60,15,"PCM");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CONTROLS_PCM);
  fdui->audio_controls_master = obj = fl_add_roundbutton(FL_RADIO_BUTTON,230,40,60,15,"Master");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CONTROLS_MASTER);
  fl_end_group();


  fdui->audio_quality_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,130,25,85,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,135,15,50,20,"Quality");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_quality_low = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,90,70,15,"Low");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_LOW);
  fdui->audio_quality_medium = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,65,75,15,"Medium");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_MEDIUM);
  fdui->audio_quality_high = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,40,75,15,"High");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_HIGH);
  fl_end_group();


  fdui->audio_ports_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,305,25,90,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,310,15,40,20,"Ports");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_group();

  fdui->audio_port_line_out = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,35,75,20,"Line-out");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_LINE_OUT);
  fdui->audio_port_headphone = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,60,75,20,"Headphone");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_HEADPHONE);
  fdui->audio_port_speaker = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,85,75,20,"Speaker");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_SPEAKER);
  fl_end_form();

  fdui->audio->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_infos *create_form_infos(void)
{
  FL_OBJECT *obj;
  FD_infos *fdui = (FD_infos *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->infos = fl_bgn_form(FL_NO_BOX, 545, 335);
  obj = fl_add_box(FL_UP_BOX,0,0,545,335,"");
  obj = fl_add_box(FL_BORDER_BOX,275,15,260,35,"");
  obj = fl_add_box(FL_BORDER_BOX,10,100,255,185,"");
  obj = fl_add_box(FL_BORDER_BOX,10,15,255,60,"");
  obj = fl_add_box(FL_BORDER_BOX,275,65,260,165,"");

  fdui->audio_group = fl_bgn_group();
  obj = fl_add_text(FL_NORMAL_TEXT,475,25,55,15,"Mbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->mux_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,385,25,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,80,100,16,"Audio bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,100,100,15,"Audio layer:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_layer = obj = fl_add_text(FL_NORMAL_TEXT,385,100,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,385,80,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,120,100,15,"Audio mode:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_mode = obj = fl_add_text(FL_NORMAL_TEXT,385,120,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,475,80,55,15,"Kbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,475,141,55,15,"KHz");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,25,100,14,"Mux bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fl_end_group();


  fdui->video_group = fl_bgn_group();
  obj = fl_add_text(FL_NORMAL_TEXT,15,175,85,15,"Framerate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,50,85,15,"File size:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,196,195,60,15,"Mbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,196,175,65,15,"Frames/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->file_size = obj = fl_add_text(FL_NORMAL_TEXT,100,50,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_framerate = obj = fl_add_text(FL_NORMAL_TEXT,101,175,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,135,60,15,"Pixels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_height = obj = fl_add_text(FL_NORMAL_TEXT,100,135,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,115,60,15,"Pixels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_width = obj = fl_add_text(FL_NORMAL_TEXT,100,115,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,101,195,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,135,85,15,"Frame height:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,115,85,15,"Frame width:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,195,85,15,"Bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fl_end_group();

  obj = fl_add_text(FL_NORMAL_TEXT,15,30,85,15,"File name:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->file_name = obj = fl_add_text(FL_NORMAL_TEXT,100,30,130,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,250,305,40,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_INFOS_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,290,55,40,20,"Audio");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,25,5,35,20,"Input");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,25,90,40,20,"Video");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,140,105,17,"Sampling freq:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_frequency = obj = fl_add_text(FL_NORMAL_TEXT,385,140,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,160,105,15,"Copyrighted:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_copyright = obj = fl_add_text(FL_NORMAL_TEXT,385,160,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,180,105,16,"Original / Copy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_original = obj = fl_add_text(FL_NORMAL_TEXT,385,180,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,200,105,17,"Protected:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_protected = obj = fl_add_text(FL_NORMAL_TEXT,385,200,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,50,60,15,"K");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,196,215,60,15,"K");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,20,215,81,15,"VBV Buffer:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_vbv_buffer_size = obj = fl_add_text(FL_NORMAL_TEXT,101,215,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,215,85,15,"Constrained:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_constrained = obj = fl_add_text(FL_NORMAL_TEXT,101,235,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,20,255,81,15,"Compliant:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_compliant = obj = fl_add_text(FL_NORMAL_TEXT,101,255,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,155,85,15,"Pel aspect ratio:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_pel_aspect_ratio = obj = fl_add_text(FL_NORMAL_TEXT,101,155,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,5,50,20,"Systems");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->infos->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_sync *create_form_sync(void)
{
  FL_OBJECT *obj;
  FD_sync *fdui = (FD_sync *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->sync = fl_bgn_form(FL_NO_BOX, 270, 245);
  obj = fl_add_box(FL_UP_BOX,0,0,270,245,"");
  obj = fl_add_box(FL_BORDER_BOX,10,15,250,190,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,110,215,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SYNC_CLOSE);
  fdui->sync_reset_framerate_slider = obj = fl_add_button(FL_NORMAL_BUTTON,80,170,110,20,"Nominal framerate");
    fl_set_object_callback(obj,command,COM_SYNC_FRAMERATE_RESET);

  fdui->sync_group = fl_bgn_group();
  fdui->sync_nominal = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,90,240,15,"Play video at nominal framerate");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SYNC_NOMINAL);
  obj = fl_add_text(FL_NORMAL_TEXT,20,5,105,20,"Framerate & Sync");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->sync_ip = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,50,209,14,"Play only I- and P-frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_IP);
  fdui->sync_ipb = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,30,209,15,"Play all video frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_IPB);
  fdui->sync_sync = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,125,240,15,"Play video at specified framerate:");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_SYNC);
  fdui->sync_i = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,70,209,14,"Play only I-frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_I);
  fdui->sync_framerate_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,15,145,240,15,"frames/sec");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_BOTTOM_LEFT);
    fl_set_object_callback(obj,command,COM_SYNC_FRAMERATE);
  fl_end_group();

  fl_end_form();

  fdui->sync->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_video *create_form_video(void)
{
  FL_OBJECT *obj;
  FD_video *fdui = (FD_video *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->video = fl_bgn_form(FL_NO_BOX, 425, 340);
  obj = fl_add_box(FL_UP_BOX,0,0,425,340,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,185,310,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_VIDEO_CLOSE);
  obj = fl_add_box(FL_BORDER_BOX,220,20,195,180,"");
  fdui->video_brightness_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,45,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_BRIGHTNESS_SLIDER_RESET);
  obj = fl_add_text(FL_NORMAL_TEXT,230,10,55,20,"Controls");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_brightness_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,45,120,14,"Brightness");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_BRIGHTNESS_SLIDER);
  fdui->video_contrast_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,85,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_CONTRAST_SLIDER_RESET);
  fdui->video_contrast_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,85,120,14,"Contrast");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_CONTRAST_SLIDER);
  fdui->video_gamma_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,125,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_GAMMA_SLIDER_RESET);
  fdui->video_gamma_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,125,120,15,"Gamma correction");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_GAMMA_SLIDER);

  fdui->color_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,10,20,200,100,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,50,20,"Colors");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_dither_ordered = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,75,100,15,"Dithered");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_ORDERED);
  fdui->video_dither_color = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,95,100,15,"Full Color");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_COLOR);
  fdui->video_dither_gray = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,55,100,15,"Gray");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_GRAY);
  fdui->video_dither_none = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,35,100,15,"Off");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_NONE);
  fdui->video_dither_ordered_colormap_private = obj = fl_add_checkbutton(FL_PUSH_BUTTON,80,70,125,25,"private colormap");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_COLORMAP_PRIVATE);
  fl_end_group();


  fdui->aspect_ratio_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,10,135,200,75,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,125,80,20,"Aspect Ratio");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_aspect_ratio_coded = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,165,190,15,"Coded pel aspect ratio");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_ASPECT_RATIO_CODED);
  fdui->video_aspect_ratio_square_pels = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,145,190,15,"Square pels");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_ASPECT_RATIO_SQUARE_PELS);
  fdui->video_aspect_ratio_free = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,185,190,15,"Free");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_ASPECT_RATIO_FREE);
  fl_end_group();

  fdui->video_chroma_saturation_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,165,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_CHROMA_SATURATION_SLIDER_RESET);
  fdui->video_chroma_saturation_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,165,120,15,"Chroma saturation");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_CHROMA_SATURATION_SLIDER);

  fdui->video_layout_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,10,225,200,75,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,215,50,20,"Layout");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_layout_centered = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,255,190,15,"Centered");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_LAYOUT_CENTERED);
  fdui->video_layout_fill_window = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,235,190,15,"Fill window");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_LAYOUT_FILL_WINDOW);
  fdui->video_layout_top_left = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,275,190,15,"Top-left");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_LAYOUT_TOP_LEFT);
  fl_end_group();

  fl_end_form();

  fdui->video->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_frame_infos *create_form_frame_infos(void)
{
  FL_OBJECT *obj;
  FD_frame_infos *fdui = (FD_frame_infos *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->frame_infos = fl_bgn_form(FL_NO_BOX, 240, 195);
  obj = fl_add_box(FL_UP_BOX,0,0,240,195,"");
  obj = fl_add_text(FL_NORMAL_TEXT,10,5,150,15,"Type:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_type = obj = fl_add_text(FL_NORMAL_TEXT,160,5,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,100,165,40,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_FRAME_INFOS_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,25,155,15,"Temporal reference:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_temporal_reference = obj = fl_add_text(FL_NORMAL_TEXT,160,25,50,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,85,155,15,"Forward pred. accuracy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_forward_full_pel = obj = fl_add_text(FL_NORMAL_TEXT,160,85,60,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,105,155,15,"Backward f-code:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_backward_f_code = obj = fl_add_text(FL_NORMAL_TEXT,160,105,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,125,155,15,"Backward pred. accuracy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_backward_full_pel = obj = fl_add_text(FL_NORMAL_TEXT,160,125,60,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,65,155,15,"Forward f-code:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_forward_f_code = obj = fl_add_text(FL_NORMAL_TEXT,160,65,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,10,45,150,15,"VBV delay:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_vbv_delay = obj = fl_add_text(FL_NORMAL_TEXT,160,45,35,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,45,30,15,"sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->frame_infos->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_alert *create_form_alert(void)
{
  FL_OBJECT *obj;
  FD_alert *fdui = (FD_alert *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->alert = fl_bgn_form(FL_NO_BOX, 460, 130);
  obj = fl_add_box(FL_UP_BOX,0,0,460,130,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,205,100,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_ALERT_CLOSE);
  fdui->s1 = obj = fl_add_text(FL_NORMAL_TEXT,5,5,450,25,"Warning!");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->s2 = obj = fl_add_text(FL_NORMAL_TEXT,5,40,450,20,"");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->s3 = obj = fl_add_text(FL_NORMAL_TEXT,5,60,450,20,"");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->alert->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_license *create_form_license(void)
{
  FL_OBJECT *obj;
  FD_license *fdui = (FD_license *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->license = fl_bgn_form(FL_NO_BOX, 485, 440);
  obj = fl_add_box(FL_UP_BOX,0,0,485,440,"");
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  fdui->browser = obj = fl_add_browser(FL_NORMAL_BROWSER,10,45,465,355,"");
    fl_set_object_color(obj,FL_TOP_BCOL,FL_YELLOW);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_FIXED_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,130,410,80,20,"I Agree");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_callback(obj,command,COM_LICENSE_AGREE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,0,485,45,"MpegTV Player 1.0 is licensed software. Its use is subject to the\nterms and conditions of the license agreement below.");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthEast);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
  obj = fl_add_button(FL_NORMAL_BUTTON,270,410,80,20,"I Don't Agree");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_callback(obj,command,COM_LICENSE_DISAGREE);
  fl_end_form();

  fdui->license->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_registration *create_form_registration(void)
{
  FL_OBJECT *obj;
  FD_registration *fdui = (FD_registration *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->registration = fl_bgn_form(FL_NO_BOX, 210, 185);
  obj = fl_add_box(FL_UP_BOX,0,0,210,185,"");
  obj = fl_add_button(FL_NORMAL_BUTTON,40,150,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,command,COM_REGISTRATION_OK);
  obj = fl_add_button(FL_NORMAL_BUTTON,120,150,50,20,"Cancel");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,command,COM_REGISTRATION_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,5,200,40,"Enter your personal registration\ninformation below:");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->key = obj = fl_add_input(FL_NORMAL_INPUT,90,110,90,20,"Key:");
    fl_set_object_resize(obj, FL_RESIZE_NONE);
  fdui->name = obj = fl_add_input(FL_NORMAL_INPUT,90,50,90,20,"Name:");
    fl_set_object_resize(obj, FL_RESIZE_NONE);
  fdui->order_number = obj = fl_add_input(FL_NORMAL_INPUT,90,80,90,20,"Order number:");
    fl_set_object_resize(obj, FL_RESIZE_NONE);
  fl_end_form();

  fdui->registration->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_splash *create_form_splash(void)
{
  FL_OBJECT *obj;
  FD_splash *fdui = (FD_splash *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->splash = fl_bgn_form(FL_NO_BOX, 490, 400);
  obj = fl_add_box(FL_UP_BOX,0,0,490,400,"");
  fdui->splash_greetings = obj = fl_add_text(FL_NORMAL_TEXT,10,0,470,345,"Thanks for trying MpegTV Player 1.0\n\nThis UNREGISTERED copy is for evaluation only.\n\nYou can register your personal copy at:\n\nhttp://www.mpegtv.com/player-purchase.html\n\nRegistered copies do not display this notice.\n\nCommercial or governmental use of this product\n requires a commercial license.\nFor commercial licenses, please contact MpegTV at:\nsales@mpegtv.com\n\nMpegTV grants you the right to use this software only if you\nagree with the license terms and conditions.");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_button(FL_NORMAL_BUTTON,20,350,110,30,"Read License");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SPLASH_LICENSE);
  obj = fl_add_button(FL_NORMAL_BUTTON,190,350,110,30,"Enter Key");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SPLASH_KEY);
  fdui->button_try = obj = fl_add_button(FL_NORMAL_BUTTON,360,350,110,30,"Try it!");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SPLASH_EVALUATE);
  fl_end_form();

  fdui->splash->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_udp *create_form_udp(void)
{
  FL_OBJECT *obj;
  FD_udp *fdui = (FD_udp *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->udp = fl_bgn_form(FL_NO_BOX, 205, 80);
  obj = fl_add_box(FL_UP_BOX,0,0,205,80,"");
  obj = fl_add_button(FL_NORMAL_BUTTON,40,50,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,command,COM_UDP_OK);
  obj = fl_add_button(FL_NORMAL_BUTTON,120,50,50,20,"Cancel");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,command,COM_UDP_CLOSE);
  fdui->port = obj = fl_add_input(FL_INT_INPUT,110,15,35,20,"Port (UDP):");
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj,command,COM_UDP_OK);
  fl_end_form();

  fdui->udp->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

