/* Copyright (c) 1997, MpegTV LLC */
#ifndef _constrained_h
#define _constrained_h
#ifndef lint
static const char rcsid_constrained_h[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/RCS/constrained.h,v 1.2 1998/05/29 22:26:51 tristan Exp $";
#endif


/* maximum values for MPEG-1 constrained bitstreams */
#define CONSTRAINED_MAX_FRAME_WIDTH			768
#define CONSTRAINED_MAX_FRAME_HEIGHT		576
#define CONSTRAINED_MAX_MB_COUNT			396
#define CONSTRAINED_MAX_MB_RATE				(25 * CONSTRAINED_MAX_MB_COUNT)
#define CONSTRAINED_MAX_FRAME_RATE			30
#define CONSTRAINED_MAX_BIT_RATE			1856000
#define CONSTRAINED_MAX_VBV_BUFFER_SIZE		(20*16*1024/8)

/* maximum f-codes */
#define CONSTRAINED_MAX_F_CODE			4

#endif /* _constrained_h */
