/* Copyright (c) 1997, MpegTV LLC */
#ifndef _search_h
#define _search_h
#ifndef lint
static const char rcsid_search_h[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/RCS/search.h,v 1.2 1998/05/29 22:20:10 tristan Exp $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#ifdef HAVE_SEARCH_H

#include <search.h>

#else /* not HAVE_SEARCH_H */

#include "misc.h"
#include <db.h>

typedef struct {
	char *key;
	char *data;
} ENTRY;

typedef enum {
	FIND,
	ENTER
} ACTION;

extern int hcreate(u_int n);
extern int hdestroy(void);
extern ENTRY *hsearch(ENTRY entry, ACTION n);

#endif /* not HAVE_SEARCH_H */

#endif /* _search_h */
